

static ssize_t schar_write(struct file *file, const char *buf, size_t count,
			   loff_t *offset)
{
  char *tbuf;
  int i;
  struct net_device *dev;
  struct sk_buff *skb;
  unsigned short proto=0;

  tbuf=kmalloc(9000,GFP_KERNEL);

  dev=dev_get_by_name("eth1");
  err=-ENODEV;
  if (dev == NULL)
   goto out_unlock;
            
/*
 *      You may not queue a frame bigger than the mtu. This is the lowest level
 *      raw protocol and you must do your own fragmentation at this level.
*/
                
  err = -EMSGSIZE;
  if(len>dev->mtu+dev->hard_header_len)
  goto out_unlock;
     
  err = -ENOBUFS;
  skb = sock_wmalloc(sk, len+dev->hard_header_len+15, 0, GFP_KERNEL);
     
/*
 *      If the write buffer is full, then tough. At this level the user gets to
 *      deal with the problem - do your own algorithmic backoffs. That's far
 *      more flexible.
*/
              
  if (skb == NULL) 
  goto out_unlock;
     
/*
*      Fill it in 
*/
              
/* FIXME: Save some space for broken drivers that write a
* hard header at transmission time by themselves. PPP is the
* notable one here. This should really be fixed at the driver level.
*/
   skb_reserve(skb,(dev->hard_header_len+15)&~15);
   skb->nh.raw = skb->data;     
/* Try to align data part correctly */
   if (dev->hard_header) {
      skb->data -= dev->hard_header_len;
      skb->tail -= dev->hard_header_len;
    }     

/* Returns -EFAULT on error */
   //  err = memcpy_fromiovec(skb_put(skb,len), msg->msg_iov, len);
   err = copy_from_user(tbuf,buf, count);
   err = memcpy_fromiovec(skb_put(skb,len), tbuf, len);   
   skb->protocol = proto;
   skb->dev = dev;
   skb->priority = sk->priority;
   if (err)
   goto out_free;
     
   err = -ENETDOWN;
   if (!(dev->flags & IFF_UP))
   goto out_free;
     
/*
*      Now send it
*/
     
   dev_queue_xmit(skb);
   dev_put(dev);
   kfree(tbuf);
   return count;
     
   out_free:
     kfree_skb(skb);
   out_unlock:
      if (dev)dev_put(dev);
      kfree(tbuf);           
  return -EFAULT;
}







